
// Trionic5.h - information and definitions needed for doing things with the T5 ECU

#include "mbed.h"
#include "CAN.h"
#include "strings.h"
#include "T5Utils.h"
#include "SRecUtils.h"

#define CR 0x0D
#define NL 0x0A

#define T5SYMBOLS 'S'
#define T5VERSION 's'
#define T5WRITE 'W'

#define T5RAMSIZE 0x8000   // T5 ECU has 32 kbytes of RAM 0x8000 = 32,768 (same as MC68332 clock speed!?!) 
#define T55FLASHSIZE 0x40000   // T5 ECU has 32 kbytes of RAM 0x8000 = 32,768 (same as MC68332 clock speed!?!) 
#define T52FLASHSIZE 0x20000   // T5 ECU has 32 kbytes of RAM 0x8000 = 32,768 (same as MC68332 clock speed!?!) 

extern void Trionic5();

void Trionic5ShowHelp();
bool Trionic5ShowCANMessage();
bool Trionic5GetSymbolTable();
bool Trionic5GetVersion();
bool Trionic5GetAdaptionData();
bool Trionic5SendBootLoader();
bool Trionic5GetChecksum();
bool Trionic5BootloaderReset();
bool Trionic5GetChipTypes();
bool Trionic5EraseFLASH();
bool Trionic5DumpFLASH();
bool Trionic5DumpFLASH2();
bool Trionic5SendFLASHUpdate();
bool Trionic5SendC3Message();
